{--------------------------------------------------------------------------------
* Description : Demo application that shows all features of the TscExcelExport component
* Author : Stefan Cruysberghs
* Email : stefancr@scip.be
* Website : http://www.scip.be

* To run this application, Excel should be installed.
* Make sure to add a path to the folder with the scExcelExport.pas file
in the global Library path of Delphi
 - Tools >> Options >> Delphi Options >> Library >> Library path
 - or Tools >> Options >> Language >> Delphi >> Library >> Library path
--------------------------------------------------------------------------------}

unit MainExcelExport;

interface

{$Include scExcelExportConfig.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, Grids, DBGrids, ExtCtrls, Buttons,
  ComCtrls, OleServer, ImgList, DBClient,
  scExcelExport,
  {$IFDEF DELPHXEORHIGHER}
  System.ImageList,
  {$ENDIF}
  {$IFNDEF DELPHI5}
  Variants, jpeg, XPMan, System.ImageList, Vcl.Imaging.pngimage,
  {$ENDIF}
  {$IFDEF EXCEL97}
  Excel97;
  {$ENDIF}
  {$IFDEF EXCEL2000}
  Excel2000;
  {$ENDIF}
  {$IFDEF EXCELXP}
  ExcelXP;
  {$ENDIF}
  {$IFDEF EXCEL2010}
  Excel2010;
  {$ENDIF}

type
  TFormExcelExport = class(TForm)
    DataSourceOrders: TDataSource;
    StatusBar: TStatusBar;
    PanelTitle: TPanel;
    scExcelExport1: TscExcelExport;
    DataSourceAnimals: TDataSource;
    PageControlExcelExport: TPageControl;
    DataSourceBiolife: TDataSource;
    ImageExcelExportLogo: TImage;
    LabelTitle1: TLabel;
    LabelAuthor: TLabel;
    LabelWebsite: TLabel;
    LabelRegister: TLabel;
    LabelDelphiVersions: TLabel;
    scExcelExport2: TscExcelExport;
    ImageListTabs: TImageList;
    LabelExtraInfo: TLabel;
    LabelExcelVersions: TLabel;
    TabSheetDemos: TTabSheet;
    TabSheetDatasets: TTabSheet;
    PageControlDemos: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    PageControlDatasets: TPageControl;
    TabSheetDatasetOrders: TTabSheet;
    TabSheetDatasetAnimals: TTabSheet;
    PanelOrders: TPanel;
    DBGridOrders: TDBGrid;
    DBGridAnimals: TDBGrid;
    PanelAnimals: TPanel;
    TabSheetDatasetBiolife: TTabSheet;
    PanelBiolife: TPanel;
    DBGridBiolife: TDBGrid;
    TabSheetDatasetShipVia: TTabSheet;
    PanelSortShipVia: TPanel;
    DBGridShipVia: TDBGrid;
    DataSourceShipVia: TDataSource;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    TabSheet13: TTabSheet;
    TabSheet14: TTabSheet;
    TabSheet15: TTabSheet;
    TabSheet16: TTabSheet;
    TabSheet17: TTabSheet;
    TabSheet18: TTabSheet;
    PanelNumber1: TPanel;
    PanelTitle1: TPanel;
    Memo1: TMemo;
    BitBtnExecute1: TBitBtn;
    PanelNumber2: TPanel;
    PanelTitle2: TPanel;
    Memo2: TMemo;
    BitBtnExecute2: TBitBtn;
    PanelNumber3: TPanel;
    PanelTitle3: TPanel;
    Memo3: TMemo;
    BitBtnExecute3: TBitBtn;
    PanelNumber4: TPanel;
    PanelTitle4: TPanel;
    Memo4: TMemo;
    BitBtnExecute4: TBitBtn;
    PanelNumber5: TPanel;
    PanelTitle5: TPanel;
    Memo5: TMemo;
    BitBtnExecute5: TBitBtn;
    Panel9: TPanel;
    PanelTitle6: TPanel;
    Memo6: TMemo;
    BitBtnExecute6: TBitBtn;
    Panel11: TPanel;
    PanelTitle7: TPanel;
    Memo7: TMemo;
    BitBtnExecute7: TBitBtn;
    Panel13: TPanel;
    PanelTitle8: TPanel;
    Memo8: TMemo;
    BitBtnExecute8: TBitBtn;
    PanelNumber9: TPanel;
    PanelTitle9: TPanel;
    Memo9: TMemo;
    BitBtnExecute9: TBitBtn;
    PanelNumber10: TPanel;
    PanelTitle10: TPanel;
    Memo10: TMemo;
    BitBtnExecute10: TBitBtn;
    PanelNumber11: TPanel;
    PanelTitle11: TPanel;
    Memo11: TMemo;
    BitBtnExecute11: TBitBtn;
    PanelNumber12: TPanel;
    PanelTitle12: TPanel;
    Memo12: TMemo;
    BitBtnExecute12: TBitBtn;
    PanelNumber13: TPanel;
    PanelTitle13: TPanel;
    Memo13: TMemo;
    BitBtnExecute13: TBitBtn;
    PanelNumber14: TPanel;
    PanelTitle14: TPanel;
    Memo14: TMemo;
    BitBtnExecute14: TBitBtn;
    Panel27: TPanel;
    PanelTitle15: TPanel;
    Memo15: TMemo;
    BitBtnExecute15: TBitBtn;
    Panel29: TPanel;
    PanelTitle16: TPanel;
    Memo16: TMemo;
    BitBtnExecute16: TBitBtn;
    Panel31: TPanel;
    PanelTitle17: TPanel;
    Memo17: TMemo;
    BitBtnExecute17: TBitBtn;
    Panel33: TPanel;
    Panel34: TPanel;
    Memo18: TMemo;
    BitBtnExecute18: TBitBtn;
    Image13: TImage;
    Image2: TImage;
    Image6: TImage;
    Image7: TImage;
    Image12: TImage;
    Image9: TImage;
    Bevel9: TBevel;
    Bevel2: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel12: TBevel;
    Bevel13: TBevel;
    Bevel14: TBevel;
    Image14: TImage;
    Bevel15: TBevel;
    Image15: TImage;
    TabSheet19: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtnExecute19: TBitBtn;
    ListBoxResults: TListBox;
    BitBtnExecute19b: TBitBtn;
    BitBtnGetExcelDateFormat: TBitBtn;
    EditDateFormat: TEdit;
    ClientDataSetAnimals: TClientDataSet;
    ClientDataSetBiolife: TClientDataSet;
    ClientDataSetOrders: TClientDataSet;
    ClientDataSetAnimalsNAME: TStringField;
    ClientDataSetAnimalsSIZE: TSmallintField;
    ClientDataSetAnimalsWEIGHT: TSmallintField;
    ClientDataSetAnimalsAREA: TStringField;
    ClientDataSetAnimalsBMP: TBlobField;
    ClientDataSetAnimalsWeightSize: TFloatField;
    ClientDataSetAnimalsAreaText: TStringField;
    ClientDataSetAnimalsSizeText: TStringField;
    ClientDataSetAnimalsWeight2: TFloatField;
    ClientDataSetAnimalsWeight3: TFloatField;
    ClientDataSetAnimalsWeight4: TStringField;
    ClientDataSetAnimalsWeight5: TCurrencyField;
    ClientDataSetAnimalsWeight6: TCurrencyField;
    ClientDataSetAnimalsWeight7: TFloatField;
    ClientDataSetAnimalsTime1: TDateTimeField;
    ClientDataSetAnimalsTime2: TDateTimeField;
    ClientDataSetAnimalsTime3: TDateTimeField;
    ClientDataSetAnimalsTime4: TDateTimeField;
    ClientDataSetAnimalsTime5: TDateTimeField;
    ClientDataSetAnimalsTime6: TDateField;
    ClientDataSetBiolifeSpeciesNo: TFloatField;
    ClientDataSetBiolifeCategory: TStringField;
    ClientDataSetBiolifeCommon_Name: TStringField;
    ClientDataSetBiolifeSpeciesName: TStringField;
    ClientDataSetBiolifeLengthcm: TFloatField;
    ClientDataSetBiolifeLength_In: TFloatField;
    ClientDataSetBiolifeNotes: TMemoField;
    ClientDataSetBiolifeGraphic: TGraphicField;
    ClientDataSetOrdersOrderNo: TFloatField;
    ClientDataSetOrdersCustNo: TFloatField;
    ClientDataSetOrdersSaleDate: TDateTimeField;
    ClientDataSetOrdersShipDate: TDateTimeField;
    ClientDataSetOrdersEmpNo: TIntegerField;
    ClientDataSetOrdersShipToContact: TStringField;
    ClientDataSetOrdersShipToAddr1: TStringField;
    ClientDataSetOrdersShipToAddr2: TStringField;
    ClientDataSetOrdersShipToCity: TStringField;
    ClientDataSetOrdersShipToState: TStringField;
    ClientDataSetOrdersShipToZip: TStringField;
    ClientDataSetOrdersShipToCountry: TStringField;
    ClientDataSetOrdersShipToPhone: TStringField;
    ClientDataSetOrdersShipVIA: TStringField;
    ClientDataSetOrdersPO: TStringField;
    ClientDataSetOrdersTerms: TStringField;
    ClientDataSetOrdersPaymentMethod: TStringField;
    ClientDataSetOrdersItemsTotal: TCurrencyField;
    ClientDataSetOrdersTaxRate: TFloatField;
    ClientDataSetOrdersFreight: TCurrencyField;
    ClientDataSetOrdersAmountPaid: TCurrencyField;
    ClientDataSetShipVia: TClientDataSet;
    ClientDataSetShipViaShipVia: TStringField;
    ClientDataSetShipViaTerms: TStringField;
    ClientDataSetShipViaOrderNo: TFloatField;
    ClientDataSetShipViaCustNo: TFloatField;
    ClientDataSetShipViaSaleDate: TDateTimeField;
    ClientDataSetShipViaNewOrderNo: TFloatField;
    ClientDataSetShipViaAmountPaid: TCurrencyField;
    procedure FormCreate(Sender: TObject);
    procedure BitBtnExecute18Click(Sender: TObject);
    procedure BitBtnExecute17Click(Sender: TObject);
    procedure BitBtnExecute15Click(Sender: TObject);
    procedure BitBtnExecute16Click(Sender: TObject);
    procedure BitBtnExecute14Click(Sender: TObject);
    procedure BitBtnExecute13Click(Sender: TObject);
    procedure BitBtnExecute12Click(Sender: TObject);
    procedure BitBtnExecute11Click(Sender: TObject);
    procedure BitBtnExecute10Click(Sender: TObject);
    procedure BitBtnExecute9Click(Sender: TObject);
    procedure BitBtnExecute8Click(Sender: TObject);
    procedure BitBtnExecute7Click(Sender: TObject);
    procedure BitBtnExecute6Click(Sender: TObject);
    procedure BitBtnExecute5Click(Sender: TObject);
    procedure BitBtnExecute4Click(Sender: TObject);
    procedure BitBtnExecute3Click(Sender: TObject);
    procedure BitBtnExecute2Click(Sender: TObject);
    procedure BitBtnExecute1Click(Sender: TObject);
    procedure scExcelExport2GetFieldCellStyleEvent(Sender: TObject; const IntFieldIndex: Integer;
      var ColorBackground: TColor; FontCell: TxlFont);
    procedure scExcelExport1ExportRecords(Sender: TObject; IntRecordNumber: Integer);
    procedure scExcelExport2GetEOF(Sender: TObject; var BlnEOF: Boolean);
    procedure scExcelExport2GetFieldCount(Sender: TObject;
      var IntFieldCount: Integer);
    procedure scExcelExport2GetFieldDataSize(Sender: TObject;
      const FieldIndex: Integer; var IntFieldDataSize: Integer);
    procedure scExcelExport2GetFieldDataType(Sender: TObject;
      const FieldIndex: Integer; var FieldDataType: TFieldType);
    procedure scExcelExport2GetFieldDisplayName(Sender: TObject;
      const FieldIndex: Integer; var StrFieldDisplayName: String);
    procedure scExcelExport2GetFieldName(Sender: TObject;
      const FieldIndex: Integer; var StrFieldName: String);
    procedure scExcelExport2GetFieldValue(Sender: TObject;
      const FieldIndex: Integer; var VarValue: Variant);
    procedure scExcelExport2GetFieldVisible(Sender: TObject;
      const FieldIndex: Integer; var BlnFieldVisible: Boolean);
    procedure scExcelExport2ExportRecords(Sender: TObject;
      IntRecordNumber: Integer);
    procedure scExcelExport2GotoFirstRecord(Sender: TObject);
    procedure scExcelExport2GotoNextRecord(Sender: TObject);
    procedure LabelWebsiteClick(Sender: TObject);
    procedure BitBtnExecute19Click(Sender: TObject);
    procedure BitBtnExecute19bClick(Sender: TObject);
    procedure BitBtnGetExcelDateFormatClick(Sender: TObject);
    procedure ClientDataSetAnimalsCalcFields(DataSet: TDataSet);
    procedure ClientDataSetBiolifeNotesGetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
  private
    procedure ChangeCellColors(Sender: TObject; Field: TField; var ColorBackground : TColor; FontCell : TxlFont);
  public
  end;

var
  FormExcelExport: TFormExcelExport;

implementation

uses ShellAPI, {$IFNDEF DELPHI5}DateUtils,{$ENDIF} ActiveX;

{$R *.DFM}

procedure TFormExcelExport.scExcelExport1ExportRecords(Sender: TObject;
  IntRecordNumber: Integer);
begin
  StatusBar.Panels[0].Text := 'Records : '+IntToStr(IntRecordNumber);
end;

procedure TFormExcelExport.ChangeCellColors(Sender: TObject; Field: TField; var ColorBackground : TColor; FontCell : TxlFont);
begin
  if Field.FieldName = 'CustNo' then
  begin
    if Field.Value > 2000 then
    begin
      FontCell.Color := clRed;
      FontCell.Name  := 'Times New Roman';
      FontCell.Size := 14;
      FontCell.Alignment := haLeft;
      FontCell.VerticalAlignment := vaTop;
    end;
    if Field.Value > 3000 then
    begin
      FontCell.Color := clGreen;
      FontCell.Style := [fsBold];
    end;
  end;

  if Field.FieldName = 'EmpNo' then
  begin
    if Field.Dataset.FieldByName('CustNo').Value > 2000 then
    begin
      ColorBackground := clRed;
      FontCell.Style := [fsItalic];
    end;
  end;

  if Field.DataSet.FieldByName('EmpNo').Value > 100 then
    ColorBackground := clYellow;
end;

procedure TFormExcelExport.ClientDataSetAnimalsCalcFields(DataSet: TDataSet);
var
  StrSize : String;
  IntLength : Integer;
begin
  Dataset.FieldByName('WeightSize').AsFloat :=
    Dataset.FieldByName('Weight').AsFloat * Dataset.FieldByName('Size').AsFloat;
  Dataset.FieldByName('AreaText').AsString :=
    LowerCase(Dataset.FieldByName('Area').AsString)+
    '-'+
    LowerCase(Dataset.FieldByName('Area').AsString);

  Dataset.FieldByName('Weight2').AsFloat := Dataset.FieldByName('Weight').AsFloat * 12.34;
  Dataset.FieldByName('Weight3').AsFloat := Dataset.FieldByName('Weight').AsFloat * 12.34;
  Dataset.FieldByName('Weight4').AsFloat := Dataset.FieldByName('Weight').AsFloat * 12.34;
  Dataset.FieldByName('Weight5').AsCurrency := Dataset.FieldByName('Weight').AsFloat * 12.34;
  Dataset.FieldByName('Weight6').AsCurrency := Dataset.FieldByName('Weight').AsFloat * 12.34;
  Dataset.FieldByName('Weight7').AsFloat := Dataset.FieldByName('Weight').AsFloat * 1234.56;

  {$IFDEF DELPHI5}
  Dataset.FieldByName('Time1').AsDateTime :=
    EncodeDate(2004,01,20)
    +EncodeTime(10,11,12,0)
    +Dataset.FieldByName('Weight').AsFloat*1.1;
  {$ELSE}
  Dataset.FieldByName('Time1').AsDateTime := EncodeDateTime(2004,01,20,10,11,12,0)
    +Dataset.FieldByName('Weight').AsFloat*1.1;
  {$ENDIF}

  Dataset.FieldByName('Time2').AsDateTime := Dataset.FieldByName('Time1').AsDateTime;
  Dataset.FieldByName('Time3').AsDateTime := Dataset.FieldByName('Time1').AsDateTime;
  Dataset.FieldByName('Time4').AsDateTime := Dataset.FieldByName('Time1').AsDateTime;
  Dataset.FieldByName('Time5').AsDateTime := Dataset.FieldByName('Time1').AsDateTime;
  Dataset.FieldByName('Time6').AsDateTime := Dataset.FieldByName('Time1').AsDateTime;

  StrSize := Dataset.FieldByName('Size').AsString;
  IntLength := Length(StrSize);
  StrSize := StringOfChar('0',10-IntLength)+StrSize;
  Dataset.FieldByName('SizeText').AsString := StrSize;
end;

procedure TFormExcelExport.ClientDataSetBiolifeNotesGetText(Sender: TField;
  var Text: string; DisplayText: Boolean);
begin
  Text := UpperCase(Copy(Sender.AsString,1,50));
end;

procedure TFormExcelExport.FormCreate(Sender: TObject);
begin
  PageControlExcelExport.ActivePage := TabSheetDemos;
  PageControlDemos.ActivePage := TabSheet1;

  ClientDataSetAnimals.LoadFromFile(GetCurrentDir + '\Data\Animals.cds');
  ClientDataSetBiolife.LoadFromFile(GetCurrentDir + '\Data\Biolife.cds');
  ClientDataSetOrders.LoadFromFile(GetCurrentDir + '\Data\Orders.cds');
  ClientDataSetShipVia.LoadFromFile(GetCurrentDir + '\Data\ShipVia.cds');
end;

procedure TFormExcelExport.scExcelExport2GetEOF(Sender: TObject; var BlnEOF: Boolean);
begin
  BlnEOF := ClientDatasetShipVia.Eof;
end;

procedure TFormExcelExport.scExcelExport2GetFieldCount(Sender: TObject;
  var IntFieldCount: Integer);
begin
  IntFieldCount := ClientDatasetShipVia.FieldCount;
end;

procedure TFormExcelExport.scExcelExport2GetFieldDataSize(Sender: TObject;
  const FieldIndex: Integer; var IntFieldDataSize: Integer);
begin
  IntFieldDataSize := ClientDatasetShipVia.Fields[FieldIndex].Size;
end;

procedure TFormExcelExport.scExcelExport2GetFieldDataType(Sender: TObject;
  const FieldIndex: Integer; var FieldDataType: TFieldType);
begin
  FieldDataType := ClientDatasetShipVia.Fields[FieldIndex].DataType;

  if SameText(ClientDatasetShipVia.Fields[FieldIndex].FieldName,'NewOrderNo') then
    FieldDataType := ftString;
  if SameText(ClientDatasetShipVia.Fields[FieldIndex].FieldName,'SaleDate') then
    FieldDataType := ftDate;
end;

procedure TFormExcelExport.scExcelExport2GetFieldDisplayName(
  Sender: TObject; const FieldIndex: Integer;
  var StrFieldDisplayName: String);
begin
  StrFieldDisplayName := '* '+ClientDatasetShipVia.Fields[FieldIndex].FieldName+' *';
end;

procedure TFormExcelExport.scExcelExport2GetFieldName(Sender: TObject;
  const FieldIndex: Integer; var StrFieldName: String);
begin
  StrFieldName := ClientDatasetShipVia.Fields[FieldIndex].FieldName;
end;

procedure TFormExcelExport.scExcelExport2GetFieldValue(Sender: TObject;
  const FieldIndex: Integer; var VarValue: Variant);
begin
  VarValue := ClientDatasetShipVia.Fields[FieldIndex].Value;

  if SameText(ClientDatasetShipVia.Fields[FieldIndex].FieldName,'NewOrderNo') then
    VarValue := '00'+ClientDatasetShipVia.Fields[FieldIndex].AsString;
end;

procedure TFormExcelExport.scExcelExport2GotoFirstRecord(Sender: TObject);
begin
  ClientDatasetShipVia.First;
end;

procedure TFormExcelExport.scExcelExport2GotoNextRecord(Sender: TObject);
begin
  ClientDatasetShipVia.Next;
end;

procedure TFormExcelExport.scExcelExport2GetFieldVisible(Sender: TObject;
  const FieldIndex: Integer; var BlnFieldVisible: Boolean);
begin
  BlnFieldVisible := True;
end;

procedure TFormExcelExport.scExcelExport2ExportRecords(Sender: TObject;
  IntRecordNumber: Integer);
begin
  StatusBar.Panels[0].Text := 'Records : '+IntToStr(IntRecordNumber);
end;

procedure TFormExcelExport.scExcelExport2GetFieldCellStyleEvent(Sender: TObject;
  const IntFieldIndex: Integer; var ColorBackground: TColor; FontCell: TxlFont);
begin
  if ClientDatasetShipVia.FieldByName('OrderNo').Value < 1010 then
    ColorBackground := clYellow;

  if IntFieldIndex = 4 then
  begin
    if ClientDatasetShipVia.FieldByName('CustNo').Value > 2000 then
    begin
      FontCell.Color := clRed;
      FontCell.Style := [fsItalic];
      FontCell.Size  := 14;
      FontCell.VerticalAlignment := vaTop;
      FontCell.Alignment := haLeft;
    end;
  end;
end;

procedure TFormExcelExport.LabelWebsiteClick(Sender: TObject);
begin
  ShellExecute(Handle,'open','http://www.scip.be',nil,nil,SW_NORMAL);
end;

procedure TFormExcelExport.BitBtnExecute1Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetOrders;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 1';
    Duration := Now();
    scExcelExport1.ExportDataset;

    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute2Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetAnimals;
    ClientDatasetAnimalsBMP.Visible := false;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 2';
    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport1.Disconnect;
    ClientDatasetAnimalsBMP.Visible := true;
  end;
end;

procedure TFormExcelExport.BitBtnExecute3Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetBiolife;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 3';
    scExcelExport1.HeaderText.Text:= 'DEMO 3 - Animals - Memo';
    scExcelExport1.StyleColumnWidth := cwAutoFit;
    scExcelExport1.BorderData.BackColor := clGreen;
    scExcelExport1.BorderData.BackAlternateColor := clYellow;
    scExcelExport1.AutoFilter := True;
    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute4Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetBiolife;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 4';
    Duration := Now();
    ClientDatasetBiolifeNotes.OnGetText := ClientDatasetBiolifeNotesGetText;
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);

    ClientDatasetOrdersShipToPhone.Index := 10;
  finally
    ClientDatasetBiolifeNotes.OnGetText := nil;
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute5Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.WorksheetName := 'TscExcelExport DEMO 5';
    scExcelExport1.Dataset:=ClientDatasetOrders;

    scExcelExport1.SummarySelection := ssValues;
    scExcelExport1.SummaryCalculation := scSUM;
    scExcelExport1.ExcelVisible:=True;
    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute6Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.WorksheetName := 'TscExcelExport DEMO 6';
    scExcelExport1.Dataset:=ClientDatasetOrders;
    scExcelExport1.StyleColumnWidth:=cwOwnerWidth;
    scExcelExport1.ColumnWidth := 20;

    scExcelExport1.HeaderText.Text:= 'Header';
    scExcelExport1.HeaderText.Add('Header - Line2');
    scExcelExport1.HeaderText.Add('Header - Line3');
    scExcelExport1.FooterText.Add('Footer - Line1');
    scExcelExport1.FooterText.Add('Footer - Line2');
    scExcelExport1.BeginRowHeader := 5;
    scExcelExport1.BorderHeader.BackColor := clGreen;
    scExcelExport1.FontHeader.Size := 14;
    scExcelExport1.FontHeader.Color := clRed;
    scExcelExport1.MergeHeaderCells := False;
    scExcelExport1.MergeFooterCells := False;

    scExcelExport1.FontData.Size := 12;

    scExcelExport1.BeginRowTitles := 5;
    scExcelExport1.FontTitles := TxlFont(PanelTitle6.Font);
    scExcelExport1.FontTitles.Orientation := 45;
    scExcelExport1.BorderTitles.BackColor := clBlue;
    scExcelExport1.BorderTitles.BorderColor := clRed;
    scExcelExport1.BorderTitles.LineStyle := blDouble;
    scExcelExport1.BorderTitles.Weight := bwThick;

    scExcelExport1.BeginRowData := 8;
    scExcelExport1.SummarySelection := ssValues;
    scExcelExport1.SummaryCalculation := scMAX;
    scExcelExport1.BorderSummary.BackColor := clYellow;
    scExcelExport1.BorderSummary.BorderColor := clRed;
    scExcelExport1.BorderSummary.LineStyle := blLine;
    scExcelExport1.BorderSummary.Weight := bwThick;

    scExcelExport1.BorderData.LineStyle := blDouble;

    scExcelExport1.ExcelVisible:=True;
    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);

    MessageDlg(
      'First empty row in column A : ' + IntToStr(scExcelExport1.FindFirstEmptyRow('A')) + #13+#10 +
      'First empty row after row 5 in column A : ' + IntToStr(scExcelExport1.FindFirstEmptyRow('A',5)) + #13+#10 +
      'First empty row after row 10 in column A : ' + IntToStr(scExcelExport1.FindFirstEmptyRow('A',10)) + #13+#10 +
      'First empty row after row 10 in column C : ' + IntToStr(scExcelExport1.FindFirstEmptyRow('C',10))
      , mtInformation, [mbOK], 0);
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute7Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetOrders;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 7';
    scExcelExport1.FontData.Color := clBlue;
    scExcelExport1.OnGetCellStyleEvent := ChangeCellColors;
    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport1.Disconnect;
    scExcelExport1.OnGetCellStyleEvent := nil;
  end;
end;

procedure TFormExcelExport.BitBtnExecute8Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetOrders;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 8';
    scExcelExport1.FontData.Color := clBlue;
    scExcelExport1.VisibleFieldsOnly := True;
    ClientDatasetOrdersShipToContact.Visible := False;
    ClientDatasetOrdersShipToAddr1.Visible := False;
    ClientDatasetOrdersShipToAddr2.Visible := False;
    ClientDatasetOrdersShipToCity.Visible := False;
    ClientDatasetOrdersShipToState.Visible := False;
    ClientDatasetOrdersShipToZip.Visible := False;
    ClientDatasetOrdersShipToCountry.Visible := False;
    ClientDatasetOrdersShipToPhone.Visible := False;
    ClientDatasetOrdersShipVIA.Visible := False;
    ClientDatasetOrdersPO.Visible := False;
    ClientDatasetOrdersTerms.Visible := False;
    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    ClientDatasetOrdersShipToContact.Visible := True;
    ClientDatasetOrdersShipToAddr1.Visible := True;
    ClientDatasetOrdersShipToAddr2.Visible := True;
    ClientDatasetOrdersShipToCity.Visible := True;
    ClientDatasetOrdersShipToState.Visible := True;
    ClientDatasetOrdersShipToZip.Visible := True;
    ClientDatasetOrdersShipToCountry.Visible := True;
    ClientDatasetOrdersShipToPhone.Visible := True;
    ClientDatasetOrdersShipVIA.Visible := True;
    ClientDatasetOrdersPO.Visible := True;
    ClientDatasetOrdersTerms.Visible := True;
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute9Click(Sender: TObject);
begin
  try
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.ExcelVisible:=False;
    scExcelExport1.WorksheetName := 'TscExcelExport DEMO 9';
    scExcelExport1.Dataset:=ClientDatasetOrders;
    StatusBar.Panels[1].Text := '';
    scExcelExport1.ExportDataset;

    scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExportDefault',ffDefault); //without file extension

    // Excel 2007 bta Open XML format (file extension XLSX)
    if scExcelExport1.ExcelVersion = 12 then
      scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExport2007.xlsx',ffXLSX);

    // Excel 2000/XP/2003 format (file extension XLS)
    scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExport2003.xls',ffXLS);

    // Excel 95 and 97 compatible format
    // Does not work in Excel 2007
    if scExcelExport1.ExcelVersion <> 12 then
      scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExport97.xls',ffXL97);

    scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExportCSV.csv',ffCSV);

    // HTML
    // Only works with Excel 2000/XP/2003/2007
    if scExcelExport1.ExcelVersion >= 10 then
      scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExportHTM.htm',ffHTM);

    // XML spreadsheet
    // Only works with Excel XP/2003/2007
    if scExcelExport1.ExcelVersion >= 11 then
      scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExportXML.xml',ffXML);
  finally
    scExcelExport1.Disconnect(True);
  end;
end;

procedure TFormExcelExport.BitBtnExecute10Click(Sender: TObject);
begin
  try
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.ExcelVisible:=False;
    scExcelExport1.WorksheetName := 'TscExcelExport DEMO 10';
    scExcelExport1.Dataset:=ClientDatasetOrders;
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := '';
    scExcelExport1.ExcelWorkSheet.PageSetup.Orientation := xlLandscape;
    scExcelExport1.PrintPreview(True);
  finally
    scExcelExport1.Disconnect(True);
  end;
end;

procedure TFormExcelExport.BitBtnExecute11Click(Sender: TObject);
var
  Duration : TDateTime;
  intOrderNo : Integer;
  intSheetcount : Integer;
  intRecords : Integer;
begin
  scExcelExport1.ExcelVisible:=True;
  scExcelExport1.LoadDefaultProperties;

  intOrderNo := 1000;
  intRecords := 100;
  intSheetcount := 1;
  while not ClientDatasetOrders.IsEmpty do
  begin
    ClientDatasetOrders.Filtered := False;
    ClientDatasetOrders.Filter := 'OrderNo > ' + IntToStr(intOrderNo) + ' AND OrderNo < ' + IntToStr(intOrderNo+intRecords);
    ClientDatasetOrders.Filtered := True;

    scExcelExport1.Dataset:=ClientDatasetOrders;
    scExcelExport1.WorksheetName:= IntToStr(intSheetcount);

    if intSheetcount = 1 then
      scExcelExport1.ConnectTo := ctNewExcel
    else
      scExcelExport1.ConnectTo := ctNewWorksheet;
    scExcelExport1.ExportDataset;
    scExcelExport1.Disconnect;

    intOrderNo := intOrderNo + intRecords;
  end;

  Exit;

  try
    // Only use ctNewWorkbook and ctNewWorksheet when performance is
    // important and when an Excel instance has been started first
    // with ctNewExcel
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;

    // Start excel and create new workbook and worksheet Orders
    scExcelExport1.Dataset:=ClientDatasetOrders;
    scExcelExport1.WorksheetName:='Orders';
    scExcelExport1.ConnectTo := ctNewExcel;
    scExcelExport1.ShowTitles := False;
    scExcelExport1.ExportDataset;
    scExcelExport1.Disconnect;

    // Create new workbook and new worksheet Animals in active excel
    scExcelExport1.Dataset:=ClientDatasetAnimals;
    scExcelExport1.WorksheetName:='Animals';
    scExcelExport1.ConnectTo := ctNewWorkBook;
    scExcelExport1.ShowTitles := False;
    scExcelExport1.ExportDataset;
    scExcelExport1.Disconnect;

    // Create new worksheet Biolife in active workbook in active excel
    scExcelExport1.Dataset:=ClientDatasetBiolife;
    scExcelExport1.WorksheetName:='Biolife';
    scExcelExport1.ConnectTo := ctNewWorksheet;
    scExcelExport1.ShowTitles := True;
    scExcelExport1.ExportDataset;
    scExcelExport1.Disconnect;

    // Add data (of Biolife) in existing worksheet Animals
    scExcelExport1.Dataset:=ClientDatasetBiolife;
    scExcelExport1.WorksheetName:='Animals';
    scExcelExport1.ConnectTo := ctNewWorksheet;
    scExcelExport1.BeginRowTitles := 14;
    scExcelExport1.BeginRowData := 15;
    scExcelExport1.BeginColumnData := 2;
    scExcelExport1.ShowTitles := True;

    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute12Click(Sender: TObject);
begin
  // Create new workbook, add worksheet with Orders and save it
  scExcelExport1.LoadDefaultProperties;
  scExcelExport1.FontData.Color := clRed;
  scExcelExport1.ExcelVisible:=False;
  scExcelExport1.Dataset:=ClientDatasetOrders;
  scExcelExport1.WorksheetName:='Orders1';
  scExcelExport1.HeaderText.Text := 'ORDERS';
  scExcelExport1.BeginRowHeader := 1;
  scExcelExport1.BeginRowTitles := 3;
  scExcelExport1.BeginRowData := 4;
  scExcelExport1.FontHeader.Size := 12;
  scExcelExport1.FontHeader.Style := [fsBold];
  scExcelExport1.AutoFilter := True;
  scExcelExport1.ExportDataset;

  // Do not disconnect, so set other font color and other worksheet
  // and export dataset again
  scExcelExport1.FontData.Color := clGreen;
  scExcelExport1.WorksheetName:='Orders2';
  scExcelExport1.ExportDataset;

  // Save worksheet
  scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExport.xls',ffXLS);
  scExcelExport1.Disconnect;

  // Load workbook, add worksheet with Orders again to new worksheet and save it
  // Clear all properties (font, position, text, ...)
  scExcelExport1.LoadDefaultProperties;
  scExcelExport1.ExcelVisible:=False;
  scExcelExport1.Dataset:=ClientDatasetOrders;
  scExcelExport1.WorksheetName:='Orders3';
  scExcelExport1.Filename:=ExtractFilePath(Application.ExeName)+'ExcelExport.xls';
  scExcelExport1.HeaderText.Text := 'ORDERS';
  scExcelExport1.ExportDataset;
  scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExport.xls',ffXLS);
  scExcelExport1.Disconnect;

  // Load workbook, add worksheet with Animals and save it
  // Set font, beginrow and header
  scExcelExport1.LoadDefaultProperties;
  scExcelExport1.FontData.Name := 'Times New Roman';
  scExcelExport1.FontData.Color := clRed;
  scExcelExport1.FontHeader.Size := 16;
  scExcelExport1.BeginRowHeader := 7;
  scExcelExport1.BeginRowTitles := 9;
  scExcelExport1.BeginRowData := 10;
  scExcelExport1.HeaderText.Text := 'ANIMALS';
  scExcelExport1.StyleColumnWidth := cwAutoFit;

  scExcelExport1.ExcelVisible:=False;
  scExcelExport1.Dataset:=ClientDatasetAnimals;
  scExcelExport1.WorksheetName:='Animals';
  scExcelExport1.Filename:=ExtractFilePath(Application.ExeName)+'ExcelExport.xls';
  scExcelExport1.ExportDataset;
  scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExport.xls',ffXLS);
  scExcelExport1.Disconnect;

  // Load workbook, add worksheet with Biolife and save it
  // Clear only properties of position and text. Do not clear font
  scExcelExport1.LoadDefaultProperties([pgPositions,pgText]);
  scExcelExport1.ExcelVisible:=False;
  scExcelExport1.Dataset:=ClientDatasetBiolife;
  scExcelExport1.WorksheetName:='Biolife';
  scExcelExport1.Filename:=ExtractFilePath(Application.ExeName)+'ExcelExport.xls';
  scExcelExport1.ExportDataset;
  scExcelExport1.SaveAs(ExtractFilePath(Application.ExeName)+'ExcelExport.xls',ffXLS);
  scExcelExport1.Disconnect;

  // Load workbook, use existing worksheet Biolife, add Animals to
  // it at row 35 and column 3. Rename worksheet after exporting
  // and show the result
  // Clear all properties
  scExcelExport1.LoadDefaultProperties;
  scExcelExport1.ExcelVisible:=True; // Last action, so show the result
  scExcelExport1.Dataset:=ClientDatasetAnimals;
  scExcelExport1.WorksheetName:='Biolife'; //Existing worksheet
  scExcelExport1.Filename:=ExtractFilePath(Application.ExeName)+'ExcelExport.xls';
  scExcelExport1.BeginRowTitles := 35;
  scExcelExport1.BeginRowData := 38;
  scExcelExport1.BeginColumnHeader := 3;
  scExcelExport1.BeginColumnData := 3;
  scExcelExport1.ExportDataset;
  scExcelExport1.ExcelWorkSheet.Name := 'Biolife and Animals'; // Rename worksheet

   //scExcelExport1.ExcelWorkbook.ActiveSheet = scExcelExport1.ExcelWorkbook.Worksheets[1];
   //scExcelExport1.ExcelWorkbook.Worksheets('Biolife').Select(null, LCID);
   //scExcelExport1.ExcelWorkbook.ActiveSheet.Name = 'New name';
   //scExcelExport1.ExcelWorkbook.ActiveSheet.Next.Select;

  scExcelExport1.Disconnect;
end;

procedure TFormExcelExport.BitBtnExecute13Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetShipVia;

    scExcelExport1.SummarySelection := ssValues;
    scExcelExport1.SummaryCalculation := scAVG;
    scExcelExport1.SummaryDisplayFormat := '###0.000';
    scExcelExport1.BorderSummary.BackColor := clGreen;
    scExcelExport1.BorderSummary.BorderColor := clRed;
    scExcelExport1.BorderSummary.LineStyle := blLine;
    scExcelExport1.BorderSummary.Weight := bwThick;

    scExcelExport1.FontGroup := TxlFont(PanelTitle13.Font);
    scExcelExport1.BorderGroup.BackColor := clGray;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 13';
    scExcelExport1.StyleColumnWidth := cwEnhAutoFit;
    scExcelExport1.GroupFields.Clear;
    scExcelExport1.GroupFields.Add('ShipVia');
    scExcelExport1.GroupFields.Add('Terms');
    //scExcelExport1.GroupFields.Add('OrderNo');

    scExcelExport1.BorderHeader.BackColor := clBlue;
    scExcelExport1.FontHeader := TxlFont(PanelTitle13.Font);
    scExcelExport1.FontHeader.Alignment := haCenter;
    scExcelExport1.FontHeader.VerticalAlignment := vaTop;
    scExcelExport1.FontFooter.Alignment := haCenter;
    scExcelExport1.HeaderText.Text:= 'Header';
    scExcelExport1.HeaderText.Add('Header - Line2');
    scExcelExport1.HeaderText.Add('Header - Line3');
    scExcelExport1.FooterText.Add('Footer - Line1');
    scExcelExport1.FooterText.Add('Footer - Line2');
    scExcelExport1.MergeHeaderCells := True;
    scExcelExport1.MergeFooterCells := True;
    scExcelExport1.AutoFilter := True;
    scExcelExport1.BeginRowHeader := 2;
    scExcelExport1.BeginRowTitles := 6;

    Duration := Now();
    scExcelExport1.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute14Click(Sender: TObject);
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetAnimals;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 14';
    scExcelExport1.ConnectTo := ctNewExcel;
    scExcelExport1.Connect;
    scExcelExport1.ExcelWorkSheet.Range['A2','C8'].Borders.Color := clRed;

    scExcelExport1.ExportDataset;

    scExcelExport1.ExcelWorkSheet.Range['B5','E7'].Cells.Clear;

    scExcelExport1.ExcelWorkSheet.Range[Format('A%d',[scExcelExport1.EndRowData+3]),
      Format('A%d',[scExcelExport1.EndRowData+3])].Font.Size := 16;
    scExcelExport1.ExcelWorkSheet.Range[Format('A%d',[scExcelExport1.EndRowData+3]),
      Format('A%d',[scExcelExport1.EndRowData+3])].Value2 := 'Adding extra information to Excel worksheet';

    scExcelExport1.ExcelWorkSheet.Range['M1','M1'].Value2 := 10;
    scExcelExport1.ExcelWorkSheet.Range['M2','M2'].Value2 := 5;
    scExcelExport1.ExcelWorkSheet.Range['M3','M3'].Value2 := '=M1+M2';
    scExcelExport1.ExcelWorkSheet.Range['M3','M3'].Font.Color := clRed;

    scExcelExport1.ExcelWorkSheet.Range['N1','N20'].Value2 := 'Filling extra column with autofit';
    scExcelExport1.ExcelWorkSheet.Range['N1','N20'].Font.Size := 12;
    scExcelExport1.ExcelWorkSheet.Range['N1','N20'].Font.Color := clBlue;
    scExcelExport1.ExcelWorkSheet.Range['N1','N20'].EntireColumn.Autofit;

    scExcelExport1.ExcelWorkSheet.Range['B2','B2'].AddComment('This is comment for a cell');

    StatusBar.Panels[1].Text := '';
  finally
    scExcelExport1.Disconnect;
  end;
end;


procedure TFormExcelExport.BitBtnExecute15Click(Sender: TObject);
begin
  try
    scExcelExport1.ExcelVisible:=True;
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.Dataset:=ClientDatasetAnimals;
    scExcelExport1.WorksheetName:='TscExcelExport DEMO 15';
    scExcelExport1.ConnectTo := ctNewExcel;
    scExcelExport1.BorderTitles.BackColor := clSilver;
    scExcelExport1.AutoFilter := True;

    scExcelExport1.ExportDataset;

    scExcelExport1.ExcelWorkSheet.Range['A2','A'+IntToStr(scExcelExport1.EndRowData)].Interior.Color := clSilver;

    scExcelExport1.ExcelWorkSheet.Range['B2','B2'].Select;
    scExcelExport1.ExcelApplication.ActiveWindow.FreezePanes := True;

    scExcelExport1.ExcelWorkSheet.Range['C1','C'+IntToStr(scExcelExport1.EndRowData)].AutoFilter(3,'>=8',xlAnd,EmptyParam,True);

    {$IFNDEF EXCEL97}
    scExcelExport1.ExcelWorkBook.WebPagePreview;
    {$ENDIF}

    scExcelExport1.ExcelWorkBook.PivotTableWizard;
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnExecute16Click(Sender: TObject);
var
  Duration : TDateTime;
begin
  try
    ClientDatasetOrders.DisableControls;
    ClientDatasetOrders.First;
    scExcelExport2.ExcelVisible:=True;
    scExcelExport2.ConnectTo := ctNewExcel;
    scExcelExport2.DataPipe := dpCustom;
    scExcelExport2.GroupFields.Clear;
    scExcelExport2.GroupFields.Add('ShipVia');
	scExcelExport2.WorksheetName:='TscExcelExport DEMO 16';
    Duration := Now();
    scExcelExport2.ExportDataset;
    StatusBar.Panels[1].Text := 'Duration : '+TimeToStr(Now() - Duration);
  finally
    scExcelExport2.Disconnect;
    ClientDatasetOrders.EnableControls;
  end;
end;

procedure TFormExcelExport.BitBtnExecute17Click(Sender: TObject);
begin
  scExcelExport1.CloseAllExcelApps;
end;

procedure TFormExcelExport.BitBtnExecute18Click(Sender: TObject);
begin
  MessageDlg('Excel version = '+IntToStr(scExcelExport1.ExcelVersion), mtInformation, [mbOK], 0);
end;

procedure TFormExcelExport.BitBtnExecute19bClick(Sender: TObject);
begin
  ListBoxResults.Items.Add('0001 A   = ' + scExcelExport1.GetColumnCharacters(1));
  ListBoxResults.Items.Add('0015 O   = ' + scExcelExport1.GetColumnCharacters(15));
  ListBoxResults.Items.Add('0026 Z   = ' + scExcelExport1.GetColumnCharacters(26));
  ListBoxResults.Items.Add('0027 AA  = ' + scExcelExport1.GetColumnCharacters(27));
  ListBoxResults.Items.Add('0028 AB  = ' + scExcelExport1.GetColumnCharacters(28));
  ListBoxResults.Items.Add('0150 ET  = ' + scExcelExport1.GetColumnCharacters(150));
  ListBoxResults.Items.Add('0257 IW  = ' + scExcelExport1.GetColumnCharacters(257));
  ListBoxResults.Items.Add('0675 YY  = ' + scExcelExport1.GetColumnCharacters(675));
  ListBoxResults.Items.Add('0676 YZ  = ' + scExcelExport1.GetColumnCharacters(676));
  ListBoxResults.Items.Add('0677 ZA  = ' + scExcelExport1.GetColumnCharacters(677));
  ListBoxResults.Items.Add('0701 ZY  = ' + scExcelExport1.GetColumnCharacters(701));
  ListBoxResults.Items.Add('0702 ZZ  = ' + scExcelExport1.GetColumnCharacters(702));
  ListBoxResults.Items.Add('0703 AAA = ' + scExcelExport1.GetColumnCharacters(703));
  ListBoxResults.Items.Add('0704 AAB = ' + scExcelExport1.GetColumnCharacters(704));
  ListBoxResults.Items.Add('0886 AHB = ' + scExcelExport1.GetColumnCharacters(886));
  ListBoxResults.Items.Add('0951 AJO = ' + scExcelExport1.GetColumnCharacters(0951));
  ListBoxResults.Items.Add('1082 AOP = ' + scExcelExport1.GetColumnCharacters(1082));
  ListBoxResults.Items.Add('1200 ATD = ' + scExcelExport1.GetColumnCharacters(1200));
  ListBoxResults.Items.Add('1313 AXM = ' + scExcelExport1.GetColumnCharacters(1313));
  ListBoxResults.Items.Add('1378 AZZ = ' + scExcelExport1.GetColumnCharacters(1378));
  ListBoxResults.Items.Add('1379 BAA = ' + scExcelExport1.GetColumnCharacters(1379));
  ListBoxResults.Items.Add('1406 BBB = ' + scExcelExport1.GetColumnCharacters(1406));
  ListBoxResults.Items.Add('1749 BOG = ' + scExcelExport1.GetColumnCharacters(1749));
  ListBoxResults.Items.Add('2055 CAA = ' + scExcelExport1.GetColumnCharacters(2055));
  ListBoxResults.Items.Add('2500 CRD = ' + scExcelExport1.GetColumnCharacters(2500));
  ListBoxResults.Items.Add('4028 EXX = ' + scExcelExport1.GetColumnCharacters(4028));
  ListBoxResults.Items.Add('5545 HEG = ' + scExcelExport1.GetColumnCharacters(5545));
end;

procedure TFormExcelExport.BitBtnExecute19Click(Sender: TObject);
var
  StrCell : String;
  i : Integer;
begin
  try
    scExcelExport1.LoadDefaultProperties;
    scExcelExport1.ConnectTo := ctNewExcel;
    scExcelExport1.DataPipe := dpCustom;
    scExcelExport1.Connect;
    scExcelExport1.ExportDataset();

    try
      i := 10;
      while i < scExcelExport1.ExcelRestrictions.MaxNumberOfColumns + 100 do
      begin
        StrCell := scExcelExport1.GetColumnCharacters(i) + '1';
        scExcelExport1.ExcelWorkSheet.Range[StrCell, StrCell].Value2 := IntToStr(i);
        i := i + 50;
      end;
    except
      on E : Exception do
        ShowMessage(E.Message);
    end;

    scExcelExport1.ExcelApplication.Visible[scExcelExport1.LCID] := True;

    StatusBar.Panels[1].Text := '';
  finally
    scExcelExport1.Disconnect;
  end;
end;

procedure TFormExcelExport.BitBtnGetExcelDateFormatClick(Sender: TObject);
var
  StrDateFormat : String;
begin
  scExcelExport1.LoadDefaultProperties;
  scExcelExport1.ConnectTo := ctNewExcel;
  scExcelExport1.DataPipe := dpCustom;
  scExcelExport1.Connect;
  scExcelExport1.ExportDataset();

  StrDateFormat := scExcelExport1.GetDateTimeFormat('dd/mm/yyyy');
  EditDateFormat.Text := StrDateFormat;

  scExcelExport1.ExcelWorkSheet.Range['A1','A1'].Value2 := StrToDate('31/01/2019');
  scExcelExport1.ExcelWorkSheet.Range['A1','A1'].NumberFormat := StrDateFormat;

  scExcelExport1.Disconnect;
end;

end.